<?php

namespace FiloBlu\EsbRma\Model\Event;

use FiloBlu\EsbRma\Api\Data\EventInterface;
use FiloBlu\EsbRma\Api\Data\ObjectTypeDescriptorInterface;
use FiloBlu\Esb\Framework\ObjectType\Endpoint\AbstractEndpoint;

class Event extends AbstractEndpoint implements EventInterface
{
    /**
     * @var string
     */
    private $name;
    /**
     * @var string
     */
    protected $uniqueName;

    /**
     * Event constructor.
     * @param string $name
     * @param $uniqueName
     * @param ObjectTypeDescriptorInterface $objectTypeDescriptor
     */
    public function __construct(ObjectTypeDescriptorInterface $objectTypeDescriptor, string $name = '', $uniqueName = '')
    {
        parent::__construct($objectTypeDescriptor);
        $this->name = $name;
        $this->uniqueName = $uniqueName;
    }

    /**
     * @inheritDoc
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @inheritDoc
     */
    public function getUniqueName(): string
    {
        return $this->uniqueName;
    }
}
