<?php

namespace FiloBlu\EsbRma\Observer;

use Exception;
use FiloBlu\EsbRma\Api\Data\EventInterface;
use FiloBlu\Esb\Framework\Event\EventEmitter;
use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Magento\Rma\Api\Data\RmaInterface;

/**
 *
 */
class ExtRmaShouldUpdateStatusAfter implements ObserverInterface
{
    /**
     * @var EventEmitter
     */
    private $eventEmitter;
    /**
     * @var EventInterface
     */
    private $eventToEmit;

    /**
     * ExtRmaShouldupdatestatusAfter constructor.
     * @param EventEmitter $eventEmitter
     * @param EventInterface $eventToEmit
     */
    public function __construct(
        EventEmitter $eventEmitter,
        EventInterface $eventToEmit
    ) {
        $this->eventEmitter = $eventEmitter;
        $this->eventToEmit = $eventToEmit;
    }

    /**
     * Execute observer
     *
     * @param Observer $observer
     * @return void
     * @throws Exception
     */
    public function execute(Observer $observer)
    {
        /** @var RmaInterface $rma */
        $rma = $observer->getEvent()->getRma();
        if ($rma instanceof RmaInterface) {
            $this->eventEmitter->emit($this->eventToEmit, $rma);
        } else {
            throw new \RuntimeException('Expected Object of type Rma');
        }
    }

}
